import { PaginationEvent } from './../model/pagination-event';
import { PaginationModel } from './../model/pagination-model';
import { AttributePaginationRule } from './../interface/attribute-pagination-rule';
import { LanguageLibService } from '@faab/language-lib';
import { AvailableService } from './../service/available.service';
import { ChangedColumns } from './../interface/column';
import { PaginationController } from './../interface/pagination-controller';
import { StorageService } from '@faab/storage-lib';
import { HttpService } from '@faab/http-lib';
import { Subscription, Observable } from 'rxjs';
import { PaginationService } from './../service/pagination.service';
import { OnInit, OnDestroy, EventEmitter } from '@angular/core';
import { PaginationListener } from '../interface/pagination-listener';
import { PaginationSortingDirectionEnum } from '../enum/pagination-sorting-direction.enum';
import { Router, ActivatedRoute, Params } from '@angular/router';
import { DatePipe, Location } from '@angular/common';
import { PaginationTheadCellComponentData } from '../interface/pagination-thead-cell-component-data';
import { PaginationSortingDirectionType } from '../type/pagination-sorting-direction.type';
export declare class PaginationLibComponent implements OnInit, OnDestroy {
    protected http: HttpService;
    protected storage: StorageService;
    protected location: Location;
    protected router: Router;
    protected availableService: AvailableService;
    protected activatedRoute: ActivatedRoute;
    protected language: LanguageLibService;
    protected datePipe: DatePipe;
    protected paginationService: PaginationService;
    static PARAM_FIELD: string;
    static PROPERTY_PAGE: string;
    static SEPARATOR_VALUE: string;
    static SEPARATOR_PROPERTY: string;
    static SEPARATOR_MANY_VALUE: string;
    static SEPARATOR_FILTER_COLLECTION_ITEM: string;
    static COMPONENT_NAME: string;
    _items: PaginationModel[];
    items_length: number;
    attributes: {
        [key: string]: AttributePaginationRule;
    };
    listener: PaginationListener;
    countPage: number;
    countPage_prev: number;
    countPageWithoutFilters: number;
    page: number;
    direction: PaginationSortingDirectionEnum;
    direction_default: PaginationSortingDirectionEnum;
    urlParams: any[];
    visiblePagination: boolean;
    from: number;
    to: number;
    labels: {
        [key: string]: string;
    };
    columns: Observable<any>;
    cacheKey: string;
    dateFieldParam: {
        from: any;
        to: any;
    };
    private _sort;
    private _sort_default;
    private max;
    protected generic: any;
    protected _available: boolean;
    protected prev: {
        server: string;
        url: string;
    };
    protected process_items_after_request: number;
    protected table_title: string;
    protected _subscription_available: Subscription;
    protected _subscription_activatedRoute_queryParams: Subscription;
    protected _subscription_excel_export_start: Subscription;
    protected _subscription_excel_export_ready: Subscription;
    available: boolean;
    clazz: any;
    url: string;
    server: string;
    keys: string[];
    initFilter: any;
    sort: string;
    initialization: PaginationController;
    changeColumnsActual: EventEmitter<ChangedColumns>;
    private subscription_config;
    private component_default;
    private config;
    constructor(http: HttpService, storage: StorageService, location: Location, router: Router, availableService: AvailableService, activatedRoute: ActivatedRoute, language: LanguageLibService, datePipe: DatePipe, paginationService: PaginationService);
    ngOnInit(): void;
    onInit(): void;
    ngOnDestroy(): void;
    onDestroy(): void;
    onChangedColumnsActual(changed_columns: ChangedColumns): void;
    isSortableField(key: string): boolean;
    getAttributeTitleByKey(key: string): string;
    getDirection(key: string): PaginationSortingDirectionType;
    getPaginationTheadCellComponentData(key: string): PaginationTheadCellComponentData;
    protected setInitialization(controller: any): void;
    protected preInit(): void;
    protected onPagerInit(): void;
    initCacheKey(): void;
    protected getUrl(): string;
    protected processParams(params: Params): void;
    protected readAndInitParam(params: string): void;
    protected genParams(): string;
    protected generatorRequestURL(): string;
    protected write(): void;
    get(key: string, item: PaginationModel): string;
    getNumber(key: string, item: PaginationModel): string;
    getBoolean(key: string, item: PaginationModel): string;
    getCurrency(key: string, item: PaginationModel): string | number;
    getAccordion(key: string, item: PaginationModel): any;
    getColumnType(key: string): string;
    protected getDate(key: string, item: PaginationModel): number;
    setData(item: PaginationModel[]): void;
    refresh(): void;
    clearCache(): void;
    protected getBaseUrl(): string;
    protected getLabels(key: string): string;
    protected getLocaleName(key: string[], item: object): string;
    protected getLangOffset(): 1 | 2;
    onFilterChange(event: PaginationEvent): void;
    protected changeUrl(): any[];
    pageChange(page: any): void;
    protected getData(): void;
    protected runRequest(url: string): void;
    protected executeFunctionByName(namespaces: string[], context: object): string | object;
    protected checkSubscription(subscription: Subscription): void;
    protected attributesInit(): void;
    getMax(): number;
    setConfig(): void;
    private isValidComponent;
}
