import { PaginationEventData } from './../../interface/pagination-event-data';
import { PaginationProcessData } from './../../interface/pagination-process-data';
import { PaginationTheadCellComponentInterface } from './../../interface/pagination-thead-cell-component-interface';
import { PaginationEvent } from './../../model/pagination-event';
import { EventEmitter, OnInit, OnDestroy, AfterViewInit } from '@angular/core';
import { PaginationSortingDirectionEnum } from '../../enum/pagination-sorting-direction.enum';
import { Subscription } from 'rxjs';
import { PaginationParamItem } from '../../interface/pagination-param-item';
export declare class PaginationTheadCellBaseComponent implements PaginationTheadCellComponentInterface, OnInit, OnDestroy, AfterViewInit {
    static EVENT_TYPE: string;
    static PARAM_NAME: string;
    key: string;
    title: string;
    direction: PaginationSortingDirectionEnum;
    sortable: boolean;
    changePaginationEvent: EventEmitter<PaginationEvent>;
    constructor();
    static updateEventData(event_data: PaginationEventData, process_data: PaginationProcessData): number;
    static updateEventDataByParamItem(param_item: PaginationParamItem): void;
    static getParamItem(): string;
    static generateRequestUrl(): string;
    static getValueByKey(key: string): void;
    ngOnInit(): void;
    onInit(): void;
    ngOnDestroy(): void;
    onDestroy(): void;
    ngAfterViewInit(): void;
    afterViewInit(): void;
    onChangeDirection(direction: PaginationSortingDirectionEnum): void;
    protected checkSubscription(subscription: Subscription): void;
}
